Skip to content
GitLab
Explore
Sign in
Primary navigation
Search or go to…
Project
bob.admin
Manage
Activity
Members
Labels
Plan
Issues
Issue boards
Milestones
Wiki
Code
Merge requests
Repository
Branches
Commits
Tags
Repository graph
Compare revisions
Build
Pipelines
Jobs
Pipeline schedules
Artifacts
Deploy
Releases
Container Registry
Model registry
Operate
Environments
Monitor
Incidents
Analyze
Value stream analytics
Contributor analytics
CI/CD analytics
Repository analytics
Model experiments
Help
Help
Support
GitLab documentation
Compare GitLab plans
Community forum
Contribute to GitLab
Provide feedback
Keyboard shortcuts
?
Snippets
Groups
Projects
This is an archived project. Repository and other project resources are read-only.
Show more breadcrumbs
bob
bob.admin
Commits
e34b464f
Commit
e34b464f
authored
8 years ago
by
André Anjos
Browse files
Options
Downloads
Patches
Plain Diff
Use filesystem locks to prevent concurrent use of ~/.pypirc (fixes
#11
)
parent
79197d64
No related branches found
Branches containing commit
No related tags found
No related merge requests found
Changes
4
Hide whitespace changes
Inline
Side-by-side
Showing
4 changed files
gitlab/after_deploy.sh
+1
-1
1 addition, 1 deletion
gitlab/after_deploy.sh
gitlab/before_deploy.sh
+0
-1
0 additions, 1 deletion
gitlab/before_deploy.sh
gitlab/deploy.sh
+8
-6
8 additions, 6 deletions
gitlab/deploy.sh
gitlab/functions.sh
+66
-15
66 additions, 15 deletions
gitlab/functions.sh
with
75 additions
and
23 deletions
gitlab/after_deploy.sh
+
1
−
1
View file @
e34b464f
...
@@ -3,4 +3,4 @@
...
@@ -3,4 +3,4 @@
source
$(
dirname
${
0
}
)
/functions.sh
source
$(
dirname
${
0
}
)
/functions.sh
run_cmd
rm
-rf
${
HOME
}
/.pypirc
log_info
"*** Not yet implemented ***"
This diff is collapsed.
Click to expand it.
gitlab/before_deploy.sh
+
0
−
1
View file @
e34b464f
...
@@ -3,5 +3,4 @@
...
@@ -3,5 +3,4 @@
source
$(
dirname
${
0
}
)
/functions.sh
source
$(
dirname
${
0
}
)
/functions.sh
run_cmd
rm
-f
${
HOME
}
/.pypirc
run_cmd
$(
dirname
${
0
}
)
/before_test.sh
run_cmd
$(
dirname
${
0
}
)
/before_test.sh
This diff is collapsed.
Click to expand it.
gitlab/deploy.sh
+
8
−
6
View file @
e34b464f
...
@@ -3,18 +3,20 @@
...
@@ -3,18 +3,20 @@
source
$(
dirname
${
0
}
)
/functions.sh
source
$(
dirname
${
0
}
)
/functions.sh
dot
_pypirc
lock
_pypirc
setup register
--repository
staging
setup
_deploy
register
--repository
staging
setup check sdist
--formats
zip upload
--repository
staging
setup
_deploy
check sdist
--formats
zip upload
--repository
staging
# if that worked, uploads documentation to pythonhosted if any exists
# if that worked, uploads documentation to pythonhosted if any exists
if
[
-d
sphinx
]
;
then
if
[
-d
sphinx
]
;
then
log_info
"Uploading documentation to
${
PYPISERVER
}
on behalf of
${
PYPIUSER
}
..."
log_info
"Uploading documentation to
${
PYPISERVER
}
on behalf of
${
PYPIUSER
}
..."
setup upload_docs
--upload-dir
sphinx
--repository
production
setup
_deploy
upload_docs
--upload-dir
sphinx
--repository
production
fi
fi
# if that worked, uploads source package to the production index
# if that worked, uploads source package to the production index
log_info
"Uploading package to
${
PYPISERVER
}
on behalf of
${
PYPIUSER
}
..."
log_info
"Uploading package to
${
PYPISERVER
}
on behalf of
${
PYPIUSER
}
..."
setup register
--repository
production
setup_deploy register
--repository
production
setup check sdist
--formats
zip upload
--repository
production
setup_deploy check sdist
--formats
zip upload
--repository
production
unlock_pypirc
This diff is collapsed.
Click to expand it.
gitlab/functions.sh
+
66
−
15
View file @
e34b464f
...
@@ -16,12 +16,12 @@ log_info() {
...
@@ -16,12 +16,12 @@ log_info() {
log_warn
()
{
log_warn
()
{
echo
-e
"(
`
date
+%T
`
)
\0
33[1;35mWarning:
${
@
}
\0
33[0m"
echo
-e
"(
`
date
+%T
`
)
\0
33[1;35mWarning:
${
@
}
\0
33[0m"
>
&2
}
}
log_error
()
{
log_error
()
{
echo
-e
"(
`
date
+%T
`
)
\0
33[1;31mError:
${
@
}
\0
33[0m"
echo
-e
"(
`
date
+%T
`
)
\0
33[1;31mError:
${
@
}
\0
33[0m"
>
&2
}
}
...
@@ -71,20 +71,29 @@ run_cmd() {
...
@@ -71,20 +71,29 @@ run_cmd() {
}
}
# Runs setup.py
setup
()
{
run_cmd
${
PREFIX
}
/bin/python setup.py
${
@
}
}
# Prepares ~/.pypirc
# Prepares ~/.pypirc
dot_pypirc
()
{
lock_pypirc
()
{
local
lockfile
=
/var/tmp/pypirc_lock
local
rc
=
${
HOME
}
/.pypirc
local
rc
=
${
HOME
}
/.pypirc
log_info
"Creating
${
rc
}
..."
local
maxtries
=
10
if
[
-e
${
rc
}
]
;
then
local
try
=
0
run_cmd
rm
-f
${
rc
}
local
sleeptime
=
30
#seconds
fi
cat
<<
EOT
>>
${
rc
}
while
true
;
do
if
[[
${
try
}
-lt
${
maxtries
}
]]
;
then
((
try++
))
if
(
set
-o
noclobber
;
echo
"
$$
"
>
"
${
lockfile
}
"
)
2> /dev/null
;
then
log_info
"Successfully acquired
${
lockfile
}
"
echo
$$
>
${
lockfile
}
log_info
"trapping on
${
lockfile
}
..."
trap
'rm -f "${lockfile}"; exit $?'
INT TERM EXIT
# start: protected code
log_info
"Creating
${
rc
}
..."
if
[
-e
${
rc
}
]
;
then
run_cmd
rm
-f
${
rc
}
fi
cat
<<
EOT
>>
${
rc
}
[distutils]
[distutils]
index-servers =
index-servers =
production
production
...
@@ -100,7 +109,49 @@ repository: ${TESTSERVER}
...
@@ -100,7 +109,49 @@ repository: ${TESTSERVER}
username:
${
PYPIUSER
}
username:
${
PYPIUSER
}
password:
${
PYPIPASS
}
password:
${
PYPIPASS
}
EOT
EOT
run_cmd
chmod
600
${
rc
}
run_cmd
chmod
600
${
rc
}
# end: protected code
break
else
log_warn
"
${
lockfile
}
exists, owned by process
$(
cat
$lockfile
)
"
log_info
"Will retry after a
${
sleeptime
}
seconds sleep (
${
try
}
/
${
maxtries
}
)"
run_cmd
sleep
${
sleeptime
}
fi
else
log_error
"I already retried deploying
${
try
}
times. Aborting..."
log_error
"You can retry this step when less packages are building."
exit
1
fi
done
}
# Cleans ~/.pypirc, if the lock file belongs to us
unlock_pypirc
()
{
local
lockfile
=
/var/tmp/pypirc_lock
local
rc
=
${
HOME
}
/.pypirc
# untrap if lock belongs to the running process
if
[[
$(
cat
${
lockfile
}
)
==
$$
]]
;
then
run_cmd
rm
-r
${
lockfile
}
run_cmd
rm
-rf
${
rc
}
log_info
"
$
trap - INT TERM EXIT"
trap
- INT TERM EXIT
fi
}
# Runs setup.py in a deployment context. If fails, tries to unlock
# the ${HOME}/.pypirc file lock
setup_deploy
()
{
log_info
"
$
${
@
}
"
${
PREFIX
}
/bin/python setup.py
${
@
}
local
status
=
$?
if
[
${
status
}
!=
0
]
;
then
log_error
"Command Failed
\"
${
@
}
\"
"
unlock_pypirc
#just tries
exit
${
status
}
fi
}
}
...
...
This diff is collapsed.
Click to expand it.
Preview
0%
Loading
Try again
or
attach a new file
.
Cancel
You are about to add
0
people
to the discussion. Proceed with caution.
Finish editing this message first!
Save comment
Cancel
Please
register
or
sign in
to comment